<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>

</head>

<body>
    <div class="container jumbotron">
        <form id="loginForm">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="input-email" aria-describedby="emailHelp"
                    placeholder="Enter email">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="input-password" placeholder="Password">
            </div>
            <button type="submit" class="btn btn-primary" onclick="onBtnSubmitClick()">Submit</button>
        </form>
    </div>
    <script>
        'use strict';
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        
        function onBtnSubmitClick() {
            var vLoginForm = document.getElementById("loginForm");
            vLoginForm.addEventListener("submit", function (paramEvent) {
                // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
                paramEvent.preventDefault();
            });
            var vUserObj = {
                email: "",
                password: "",
            }
            //B1 thu thập dữ liệu
            thuThapDuLieu(vUserObj);
            //B2 kiểm tra dữ liệu
            var vDuLieuHopLe = kiemTraDuLieu(vUserObj.email, vUserObj.password);
            if (vDuLieuHopLe) {
                var vXmlHttpLogin = new XMLHttpRequest();
                //B3 gọi api login
                goiApiLogin(vUserObj, vXmlHttpLogin);
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            var vLoginInfo = vXmlHttpLogin.responseText;
                            //console.log(vLoginInfo);
                            var vLoginJsonObj = JSON.parse(vLoginInfo);
                            
                           // console.log(vLoginJsonObj);
                            if (vLoginJsonObj.length > 0) {
                                alert("Đăng nhập thành công");
                            }else{
                                alert("Đăng nhập thất bại")
                            }
                        } 
                    }
            }
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function thuThapDuLieu(paramUserObj) {
            var vInputEmail = document.getElementById("input-email");
            var vInputPassword = document.getElementById("input-password");
            paramUserObj.email = vInputEmail.value.trim();
            paramUserObj.password = vInputPassword.value.trim();
        }
        function kiemTraDuLieu(paramEmail, paramPassWord) {
            var vRegexEmail = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

            if (!paramEmail.match(vRegexEmail)) {
                alert("Email không đúng định dạng");
                return false;
            }
            if (paramPassWord.length < 8) {
                alert("Mật khẩu phải từ 8 kí tự trở lên")
                return false;
            }
            return true;
        }
        function goiApiLogin(paramUserObj, paramXmlHttp) {
            const vParams = new URLSearchParams({
                email: paramUserObj.email,
                password: paramUserObj.password,

            });
           
            paramXmlHttp.open("GET", gBASE_URL + "?" + vParams.toString(), true);
            paramXmlHttp.send();
        }

    </script>
</body>

</html>